from .classifier import Classifier

try:
    from .weka_classifiers import WekaClassifiers
except:
    WekaClassifiers = None

try:
    from .cnn_caffe import CNNCaffe
except:
    CNNCaffe = None

__all__ = ["cnn_caffe",
           "classifier",
           "weka_classifiers"]


from collections import OrderedDict
from util.config import Config


_classifier_list = OrderedDict( [ 
                            ["cnn_caffe", Config("Invalid" if CNNCaffe is None else CNNCaffe.__name__,
                                WekaClassifiers is None and CNNCaffe is not None, bool, meta=CNNCaffe, hidden=CNNCaffe is None)],
                            ["weka_classifiers", Config("Invalid" if WekaClassifiers is None else WekaClassifiers.__name__,
                                WekaClassifiers is not None, bool, meta=WekaClassifiers, hidden=WekaClassifiers is None)]
                        ] )

def get_classifier_config():
    return _classifier_list

def set_classifier_config(configs):
    _classifier_list["cnn_caffe"] = Config.nvl_config(configs["cnn_caffe"], _classifier_list["cnn_caffe"])
    _classifier_list["weka_classifiers"] = Config.nvl_config(configs["weka_classifiers"], _classifier_list["weka_classifiers"])
